#!/usr/bin/perl
use Test::More tests => 22;
use POWER::Epoll;
use Errno;
no warnings 'once';
require "t/init";

syswrite W, $buf or die $!;
is(epoll_mod($epfd, fileno(W), EPOLLET), 1, 'mod W -> none');
($status, $result) = epoll_wait($epfd, 0);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(R), 'got R');
is($result->[0][1], EPOLLIN, 'R = IN');

($status, $result) = epoll_wait($epfd, 0);
is($status, 0, '0 fd ready (status)');
is($#$result, -1, '0 fd ready (result)');

is(epoll_mod($epfd, fileno(W), EPOLLET|EPOLLOUT), 1, 'mod W -> OUT');
($status, $result) = epoll_wait($epfd, 0);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(W), 'got W');
is($result->[0][1], EPOLLOUT, 'W = OUT');

$n = sysread R, $buf, 102400 or die $!;
is($n, $size, 'read $size data');

$n = syswrite W, $buf or die $!;
is($n, $size, 'write $size data');

is(epoll_del($epfd, fileno(W)), 1, 'del W');
($status, $result) = epoll_wait($epfd, 0);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(R), 'got R');
is($result->[0][1], EPOLLIN, 'R = IN');

